# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from openapi_client.models.analysis_history_entry_image_attribution_analysis_similar_files_inner import AnalysisHistoryEntryImageAttributionAnalysisSimilarFilesInner
from openapi_client.models.analysis_history_entry_image_attribution_analysis_top_metrics import AnalysisHistoryEntryImageAttributionAnalysisTopMetrics
from typing import Optional, Set
from typing_extensions import Self

class AnalysisHistoryEntryImageAttributionAnalysis(BaseModel):
    """
    Image attribution analysis extracts the analysis metrics for a given image. Metrics are as follows:    Attribution likelihood describes the probability that a piece of content from the registry had an influence on the creation of a new piece of content.    Cross-correlation describes how similar the images are, independent of spatial shifts. Color match describes how similar the color distributions of RGB are.    And pixel-wise average difference gives the average distance in between images.
    """ # noqa: E501
    similar_files: List[AnalysisHistoryEntryImageAttributionAnalysisSimilarFilesInner] = Field(alias="similarFiles")
    top_metrics: AnalysisHistoryEntryImageAttributionAnalysisTopMetrics = Field(alias="topMetrics")
    __properties: ClassVar[List[str]] = ["similarFiles", "topMetrics"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AnalysisHistoryEntryImageAttributionAnalysis from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in similar_files (list)
        _items = []
        if self.similar_files:
            for _item_similar_files in self.similar_files:
                if _item_similar_files:
                    _items.append(_item_similar_files.to_dict())
            _dict['similarFiles'] = _items
        # override the default output from pydantic by calling `to_dict()` of top_metrics
        if self.top_metrics:
            _dict['topMetrics'] = self.top_metrics.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AnalysisHistoryEntryImageAttributionAnalysis from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "similarFiles": [AnalysisHistoryEntryImageAttributionAnalysisSimilarFilesInner.from_dict(_item) for _item in obj["similarFiles"]] if obj.get("similarFiles") is not None else None,
            "topMetrics": AnalysisHistoryEntryImageAttributionAnalysisTopMetrics.from_dict(obj["topMetrics"]) if obj.get("topMetrics") is not None else None
        })
        return _obj


