# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.analysis_history_entry_lyrics_analysis_lyrics_attribution_inner import AnalysisHistoryEntryLyricsAnalysisLyricsAttributionInner
from typing import Optional, Set
from typing_extensions import Self

class AnalysisHistoryEntryLyricsAnalysis(BaseModel):
    """
    The result of the lyrics analysis.
    """ # noqa: E501
    filename: Optional[StrictStr] = Field(default=None, description="The name of the file containing the uploaded lyrics.")
    lyrics: Optional[StrictStr] = Field(default=None, description="The input lyrics.")
    lyrics_attribution: Optional[List[AnalysisHistoryEntryLyricsAnalysisLyricsAttributionInner]] = Field(default=None, description="The lyrics attribution values for the (translated) input lyrics.")
    translated_lyrics: Optional[StrictStr] = Field(default=None, description="The translated version of the lyrics, if applicable.")
    __properties: ClassVar[List[str]] = ["filename", "lyrics", "lyrics_attribution", "translated_lyrics"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AnalysisHistoryEntryLyricsAnalysis from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in lyrics_attribution (list)
        _items = []
        if self.lyrics_attribution:
            for _item_lyrics_attribution in self.lyrics_attribution:
                if _item_lyrics_attribution:
                    _items.append(_item_lyrics_attribution.to_dict())
            _dict['lyrics_attribution'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AnalysisHistoryEntryLyricsAnalysis from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "filename": obj.get("filename"),
            "lyrics": obj.get("lyrics"),
            "lyrics_attribution": [AnalysisHistoryEntryLyricsAnalysisLyricsAttributionInner.from_dict(_item) for _item in obj["lyrics_attribution"]] if obj.get("lyrics_attribution") is not None else None,
            "translated_lyrics": obj.get("translated_lyrics")
        })
        return _obj


