# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from openapi_client.models.analysis_history_entry_request_data_any_of_artist_preset_inner import AnalysisHistoryEntryRequestDataAnyOfArtistPresetInner
from typing import Optional, Set
from typing_extensions import Self

class AudioLdmRequestData(BaseModel):
    """
    AudioLdmRequestData
    """ # noqa: E501
    user_id: StrictStr
    request_id: StrictStr
    batch_size: Optional[Union[StrictFloat, StrictInt]] = None
    seed: Optional[Union[StrictFloat, StrictInt]] = None
    num_train_steps: Optional[StrictInt] = None
    text_prompt: Optional[StrictStr] = None
    artist_preset: Optional[List[AnalysisHistoryEntryRequestDataAnyOfArtistPresetInner]] = None
    __properties: ClassVar[List[str]] = ["user_id", "request_id", "batch_size", "seed", "num_train_steps", "text_prompt", "artist_preset"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AudioLdmRequestData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in artist_preset (list)
        _items = []
        if self.artist_preset:
            for _item_artist_preset in self.artist_preset:
                if _item_artist_preset:
                    _items.append(_item_artist_preset.to_dict())
            _dict['artist_preset'] = _items
        # set to None if seed (nullable) is None
        # and model_fields_set contains the field
        if self.seed is None and "seed" in self.model_fields_set:
            _dict['seed'] = None

        # set to None if text_prompt (nullable) is None
        # and model_fields_set contains the field
        if self.text_prompt is None and "text_prompt" in self.model_fields_set:
            _dict['text_prompt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AudioLdmRequestData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "user_id": obj.get("user_id"),
            "request_id": obj.get("request_id"),
            "batch_size": obj.get("batch_size"),
            "seed": obj.get("seed"),
            "num_train_steps": obj.get("num_train_steps"),
            "text_prompt": obj.get("text_prompt"),
            "artist_preset": [AnalysisHistoryEntryRequestDataAnyOfArtistPresetInner.from_dict(_item) for _item in obj["artist_preset"]] if obj.get("artist_preset") is not None else None
        })
        return _obj


