# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from openapi_client.models.ai_influence import AiInfluence
from openapi_client.models.content_type import ContentType
from openapi_client.models.create_collection_request_files_inner import CreateCollectionRequestFilesInner
from openapi_client.models.create_collection_request_synthesis_rules import CreateCollectionRequestSynthesisRules
from typing import Optional, Set
from typing_extensions import Self

class CreateCollectionRequest(BaseModel):
    """
    CreateCollectionRequest
    """ # noqa: E501
    files: Optional[Annotated[List[CreateCollectionRequestFilesInner], Field(min_length=1, max_length=100)]] = Field(default=None, description="The `files` parameter is a list of metadata of the audio, image, or video files.")
    file_paths: Optional[Annotated[List[StrictStr], Field(min_length=1, max_length=100)]] = Field(default=None, description="This field is deprecated as it was replaced with the `files` parameter. It may be removed in future versions.   The `filePaths` can either be an array of image/audio/video URLs or file paths returned from the `/ldm/upload-images`, `/audio-ldm/upload-audios`, or `/artist/post-upload-urls` endpoint. Supported formats include JPG & PNG for image, WAV & MP3 for audio, and MP4 for video.", alias="filePaths")
    upc: Optional[StrictStr] = Field(default=None, description="The UPC (Universal Product Code) is a 12-digit barcode that uniquely identifies products like albums, aiding in sales tracking and inventory management across retail and online platforms.")
    collection_name: StrictStr = Field(description="Name for the artwork collection.")
    collection_description: Optional[StrictStr] = Field(default=None, description="A description of the images in this collection.             Please describe your Collection as appropriate as possible.             This helps to train our AI to get the best results.")
    artist_name: Optional[StrictStr] = Field(default=None, description="The name of the artist for which you want to create the collection. Only user accounts connected to a label can use the artistName field.", alias="artistName")
    create_new_artist: Optional[StrictBool] = Field(default=False, description="If the artist does not exist yet in the Sureel registry, you can automatically create one here. Only user accounts connected to a label can use the createNewArtist field.", alias="createNewArtist")
    styles: Optional[StrictStr] = Field(default=None, description="Genre of the songs or styles of the images, such as “painting”, “photography”, “anime” or “digital art”.             It must be a comma-separated list of styles.")
    content_type: ContentType = Field(alias="contentType")
    use_for_training: Optional[StrictBool] = Field(default=None, description="Indicates whether to opt in to AI training or opt out. Set to true to allow data to be used for training, or false to decline.", alias="useForTraining")
    knowledge_acquisition_ratio: Optional[Union[Annotated[float, Field(le=0.2, strict=True, ge=-0.2)], Annotated[int, Field(le=0, strict=True, ge=0)]]] = Field(default=0, description="If `useForTraining` is set to true, the `knowledgeAcquisitionRatio` parameter can be used to adapt the AI model’s knowledge acquisition based on your data.", alias="knowledgeAcquisitionRatio")
    ai_influence: Optional[AiInfluence] = Field(default=None, alias="aiInfluence")
    external_id: Optional[StrictStr] = Field(default=None, description="The external ID is the ID of the collection/release/album/single/compilation in another system, e.g. OpenPlay. This ID can be used to reference the content.", alias="externalId")
    original_cover_art: Optional[StrictStr] = Field(default=None, description="The `originalCoverArt` can either be an image URL or an image path returned from the `/ldm/upload-images` or `/artist/post-upload-urls` endpoint.                 Supported formats include JPG & PNG.", alias="originalCoverArt")
    audio_language: Optional[StrictStr] = Field(default=None, description="For music, you can set the audio language of the songs.", alias="audioLanguage")
    release_date: Optional[StrictStr] = Field(default=None, description="The release date of the album/single/release/compilation. The format is YYYY-MM-DD.", alias="releaseDate")
    recording_studio: Optional[StrictStr] = Field(default=None, description="For music, you can set the recording studio.", alias="recordingStudio")
    publisher: Optional[StrictStr] = Field(default=None, description="For music, you can set the publisher.")
    producer: Optional[StrictStr] = Field(default=None, description="For music, you can set the producer.")
    composer: Optional[StrictStr] = Field(default=None, description="The person who writes the music for a song.")
    song_writer: Optional[StrictStr] = Field(default=None, description="The person who writes the lyrics and melody of a song.", alias="songWriter")
    rights_administrator: Optional[StrictStr] = Field(default=None, description="A publishing administrator or specialized entity responsible for handling administrative tasks related to rights.", alias="rightsAdministrator")
    rights_owner: Optional[StrictStr] = Field(default=None, description="The owner of a copyrighted work who has rights to reproduce, distribute, publicly perform, display, and adapt the copyrighted material.", alias="rightsOwner")
    enable_automatic_attribution_setup: Optional[StrictBool] = Field(default=True, description="Enable or disable automatic attribution setup.", alias="enableAutomaticAttributionSetup")
    synthesis_rules: Optional[CreateCollectionRequestSynthesisRules] = Field(default=None, alias="synthesisRules")
    __properties: ClassVar[List[str]] = ["files", "filePaths", "upc", "collection_name", "collection_description", "artistName", "createNewArtist", "styles", "contentType", "useForTraining", "knowledgeAcquisitionRatio", "aiInfluence", "externalId", "originalCoverArt", "audioLanguage", "releaseDate", "recordingStudio", "publisher", "producer", "composer", "songWriter", "rightsAdministrator", "rightsOwner", "enableAutomaticAttributionSetup", "synthesisRules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCollectionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in files (list)
        _items = []
        if self.files:
            for _item_files in self.files:
                if _item_files:
                    _items.append(_item_files.to_dict())
            _dict['files'] = _items
        # override the default output from pydantic by calling `to_dict()` of content_type
        if self.content_type:
            _dict['contentType'] = self.content_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ai_influence
        if self.ai_influence:
            _dict['aiInfluence'] = self.ai_influence.to_dict()
        # override the default output from pydantic by calling `to_dict()` of synthesis_rules
        if self.synthesis_rules:
            _dict['synthesisRules'] = self.synthesis_rules.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCollectionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "files": [CreateCollectionRequestFilesInner.from_dict(_item) for _item in obj["files"]] if obj.get("files") is not None else None,
            "filePaths": obj.get("filePaths"),
            "upc": obj.get("upc"),
            "collection_name": obj.get("collection_name"),
            "collection_description": obj.get("collection_description"),
            "artistName": obj.get("artistName"),
            "createNewArtist": obj.get("createNewArtist") if obj.get("createNewArtist") is not None else False,
            "styles": obj.get("styles"),
            "contentType": ContentType.from_dict(obj["contentType"]) if obj.get("contentType") is not None else None,
            "useForTraining": obj.get("useForTraining"),
            "knowledgeAcquisitionRatio": obj.get("knowledgeAcquisitionRatio") if obj.get("knowledgeAcquisitionRatio") is not None else 0,
            "aiInfluence": AiInfluence.from_dict(obj["aiInfluence"]) if obj.get("aiInfluence") is not None else None,
            "externalId": obj.get("externalId"),
            "originalCoverArt": obj.get("originalCoverArt"),
            "audioLanguage": obj.get("audioLanguage"),
            "releaseDate": obj.get("releaseDate"),
            "recordingStudio": obj.get("recordingStudio"),
            "publisher": obj.get("publisher"),
            "producer": obj.get("producer"),
            "composer": obj.get("composer"),
            "songWriter": obj.get("songWriter"),
            "rightsAdministrator": obj.get("rightsAdministrator"),
            "rightsOwner": obj.get("rightsOwner"),
            "enableAutomaticAttributionSetup": obj.get("enableAutomaticAttributionSetup") if obj.get("enableAutomaticAttributionSetup") is not None else True,
            "synthesisRules": CreateCollectionRequestSynthesisRules.from_dict(obj["synthesisRules"]) if obj.get("synthesisRules") is not None else None
        })
        return _obj


