# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.analysis_history_entry import AnalysisHistoryEntry
from typing import Optional, Set
from typing_extensions import Self

class GetAnalysisHistoryResponse(BaseModel):
    """
    GetAnalysisHistoryResponse
    """ # noqa: E501
    analysis_history: List[AnalysisHistoryEntry] = Field(alias="analysisHistory")
    last_evaluated_key: Optional[StrictStr] = Field(alias="lastEvaluatedKey")
    __properties: ClassVar[List[str]] = ["analysisHistory", "lastEvaluatedKey"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetAnalysisHistoryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in analysis_history (list)
        _items = []
        if self.analysis_history:
            for _item_analysis_history in self.analysis_history:
                if _item_analysis_history:
                    _items.append(_item_analysis_history.to_dict())
            _dict['analysisHistory'] = _items
        # set to None if last_evaluated_key (nullable) is None
        # and model_fields_set contains the field
        if self.last_evaluated_key is None and "last_evaluated_key" in self.model_fields_set:
            _dict['lastEvaluatedKey'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetAnalysisHistoryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "analysisHistory": [AnalysisHistoryEntry.from_dict(_item) for _item in obj["analysisHistory"]] if obj.get("analysisHistory") is not None else None,
            "lastEvaluatedKey": obj.get("lastEvaluatedKey")
        })
        return _obj


