# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class UpdateIpRightsRequestFilesInnerContentRights(BaseModel):
    """
    UpdateIpRightsRequestFilesInnerContentRights
    """ # noqa: E501
    recording_rights: StrictBool = Field(description="Set to true if the recording rights are owned by the artist.", alias="recordingRights")
    publishing_rights: StrictBool = Field(description="Set to true if the publishing rights are owned by the artist.", alias="publishingRights")
    cover_or_derivative_work: StrictBool = Field(description="Set to true if the song is a cover or derivative work.", alias="coverOrDerivativeWork")
    __properties: ClassVar[List[str]] = ["recordingRights", "publishingRights", "coverOrDerivativeWork"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateIpRightsRequestFilesInnerContentRights from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateIpRightsRequestFilesInnerContentRights from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "recordingRights": obj.get("recordingRights"),
            "publishingRights": obj.get("publishingRights"),
            "coverOrDerivativeWork": obj.get("coverOrDerivativeWork")
        })
        return _obj


