# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from openapi_client.models.analysis_history_entry_audio_attribution_analysis import AnalysisHistoryEntryAudioAttributionAnalysis
from openapi_client.models.analysis_history_entry_lyrics_analysis import AnalysisHistoryEntryLyricsAnalysis
from openapi_client.models.analysis_history_entry_similar_tracks_inner import AnalysisHistoryEntrySimilarTracksInner
from openapi_client.models.analysis_history_entry_status_any_of import AnalysisHistoryEntryStatusAnyOf
from openapi_client.models.artist_collections_inner_ai_check_results import ArtistCollectionsInnerAiCheckResults
from openapi_client.models.artist_profile_picture import ArtistProfilePicture
from openapi_client.models.attribution1 import Attribution1
from openapi_client.models.attribution_with_stems import AttributionWithStems
from openapi_client.models.audio_ldm_request_data import AudioLdmRequestData
from openapi_client.models.opt_out_analysis import OptOutAnalysis
from typing import Optional, Set
from typing_extensions import Self

class V1AiAudioLdmRequestIdGet200Response(BaseModel):
    """
    V1AiAudioLdmRequestIdGet200Response
    """ # noqa: E501
    status: Optional[AnalysisHistoryEntryStatusAnyOf] = None
    error_message: Optional[StrictStr] = Field(default=None, alias="errorMessage")
    endpoint: Optional[StrictStr] = None
    request_id: StrictStr = Field(alias="requestId")
    request_body: Optional[Any] = None
    created_at: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="createdAt")
    audios_signed_urls: Optional[List[StrictStr]] = Field(default=None, alias="audiosSignedUrls")
    stem_splitted_audios_signed_urls: Optional[List[StrictStr]] = Field(default=None, alias="stemSplittedAudiosSignedUrls")
    content_audio: Optional[StrictStr] = Field(default=None, alias="contentAudio")
    seed: Optional[Union[StrictFloat, StrictInt]] = None
    attribution: Optional[List[Attribution1]] = Field(default=None, description="The attribution values for the individual generated files.")
    attribution_per_collection: Optional[AttributionWithStems] = Field(default=None, alias="attributionPerCollection")
    attribution_per_track: Optional[AttributionWithStems] = Field(default=None, alias="attributionPerTrack")
    provenance: Optional[List[Attribution1]] = Field(default=None, description="The attribution values for the individual generated files.")
    artist_profile_pictures: Optional[List[ArtistProfilePicture]] = Field(default=None, alias="artistProfilePictures")
    request_data: Optional[AudioLdmRequestData] = Field(default=None, alias="requestData")
    audio_attribution_analysis: Optional[AnalysisHistoryEntryAudioAttributionAnalysis] = Field(default=None, alias="audioAttributionAnalysis")
    opt_out_analysis: Optional[OptOutAnalysis] = Field(default=None, alias="optOutAnalysis")
    lyrics_analysis: Optional[AnalysisHistoryEntryLyricsAnalysis] = Field(default=None, alias="lyricsAnalysis")
    ai_generated_likelihood: Optional[ArtistCollectionsInnerAiCheckResults] = Field(default=None, alias="aiGeneratedLikelihood")
    similar_tracks: Optional[List[AnalysisHistoryEntrySimilarTracksInner]] = Field(default=None, alias="similarTracks")
    artist_uuid: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["status", "errorMessage", "endpoint", "requestId", "request_body", "createdAt", "audiosSignedUrls", "stemSplittedAudiosSignedUrls", "contentAudio", "seed", "attribution", "attributionPerCollection", "attributionPerTrack", "provenance", "artistProfilePictures", "requestData", "audioAttributionAnalysis", "optOutAnalysis", "lyricsAnalysis", "aiGeneratedLikelihood", "similarTracks", "artist_uuid"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1AiAudioLdmRequestIdGet200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in attribution (list)
        _items = []
        if self.attribution:
            for _item_attribution in self.attribution:
                if _item_attribution:
                    _items.append(_item_attribution.to_dict())
            _dict['attribution'] = _items
        # override the default output from pydantic by calling `to_dict()` of attribution_per_collection
        if self.attribution_per_collection:
            _dict['attributionPerCollection'] = self.attribution_per_collection.to_dict()
        # override the default output from pydantic by calling `to_dict()` of attribution_per_track
        if self.attribution_per_track:
            _dict['attributionPerTrack'] = self.attribution_per_track.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in provenance (list)
        _items = []
        if self.provenance:
            for _item_provenance in self.provenance:
                if _item_provenance:
                    _items.append(_item_provenance.to_dict())
            _dict['provenance'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in artist_profile_pictures (list)
        _items = []
        if self.artist_profile_pictures:
            for _item_artist_profile_pictures in self.artist_profile_pictures:
                if _item_artist_profile_pictures:
                    _items.append(_item_artist_profile_pictures.to_dict())
            _dict['artistProfilePictures'] = _items
        # override the default output from pydantic by calling `to_dict()` of request_data
        if self.request_data:
            _dict['requestData'] = self.request_data.to_dict()
        # override the default output from pydantic by calling `to_dict()` of audio_attribution_analysis
        if self.audio_attribution_analysis:
            _dict['audioAttributionAnalysis'] = self.audio_attribution_analysis.to_dict()
        # override the default output from pydantic by calling `to_dict()` of opt_out_analysis
        if self.opt_out_analysis:
            _dict['optOutAnalysis'] = self.opt_out_analysis.to_dict()
        # override the default output from pydantic by calling `to_dict()` of lyrics_analysis
        if self.lyrics_analysis:
            _dict['lyricsAnalysis'] = self.lyrics_analysis.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ai_generated_likelihood
        if self.ai_generated_likelihood:
            _dict['aiGeneratedLikelihood'] = self.ai_generated_likelihood.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in similar_tracks (list)
        _items = []
        if self.similar_tracks:
            for _item_similar_tracks in self.similar_tracks:
                if _item_similar_tracks:
                    _items.append(_item_similar_tracks.to_dict())
            _dict['similarTracks'] = _items
        # set to None if request_body (nullable) is None
        # and model_fields_set contains the field
        if self.request_body is None and "request_body" in self.model_fields_set:
            _dict['request_body'] = None

        # set to None if attribution (nullable) is None
        # and model_fields_set contains the field
        if self.attribution is None and "attribution" in self.model_fields_set:
            _dict['attribution'] = None

        # set to None if provenance (nullable) is None
        # and model_fields_set contains the field
        if self.provenance is None and "provenance" in self.model_fields_set:
            _dict['provenance'] = None

        # set to None if artist_profile_pictures (nullable) is None
        # and model_fields_set contains the field
        if self.artist_profile_pictures is None and "artist_profile_pictures" in self.model_fields_set:
            _dict['artistProfilePictures'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1AiAudioLdmRequestIdGet200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "status": AnalysisHistoryEntryStatusAnyOf.from_dict(obj["status"]) if obj.get("status") is not None else None,
            "errorMessage": obj.get("errorMessage"),
            "endpoint": obj.get("endpoint"),
            "requestId": obj.get("requestId"),
            "request_body": obj.get("request_body"),
            "createdAt": obj.get("createdAt"),
            "audiosSignedUrls": obj.get("audiosSignedUrls"),
            "stemSplittedAudiosSignedUrls": obj.get("stemSplittedAudiosSignedUrls"),
            "contentAudio": obj.get("contentAudio"),
            "seed": obj.get("seed"),
            "attribution": [Attribution1.from_dict(_item) for _item in obj["attribution"]] if obj.get("attribution") is not None else None,
            "attributionPerCollection": AttributionWithStems.from_dict(obj["attributionPerCollection"]) if obj.get("attributionPerCollection") is not None else None,
            "attributionPerTrack": AttributionWithStems.from_dict(obj["attributionPerTrack"]) if obj.get("attributionPerTrack") is not None else None,
            "provenance": [Attribution1.from_dict(_item) for _item in obj["provenance"]] if obj.get("provenance") is not None else None,
            "artistProfilePictures": [ArtistProfilePicture.from_dict(_item) for _item in obj["artistProfilePictures"]] if obj.get("artistProfilePictures") is not None else None,
            "requestData": AudioLdmRequestData.from_dict(obj["requestData"]) if obj.get("requestData") is not None else None,
            "audioAttributionAnalysis": AnalysisHistoryEntryAudioAttributionAnalysis.from_dict(obj["audioAttributionAnalysis"]) if obj.get("audioAttributionAnalysis") is not None else None,
            "optOutAnalysis": OptOutAnalysis.from_dict(obj["optOutAnalysis"]) if obj.get("optOutAnalysis") is not None else None,
            "lyricsAnalysis": AnalysisHistoryEntryLyricsAnalysis.from_dict(obj["lyricsAnalysis"]) if obj.get("lyricsAnalysis") is not None else None,
            "aiGeneratedLikelihood": ArtistCollectionsInnerAiCheckResults.from_dict(obj["aiGeneratedLikelihood"]) if obj.get("aiGeneratedLikelihood") is not None else None,
            "similarTracks": [AnalysisHistoryEntrySimilarTracksInner.from_dict(_item) for _item in obj["similarTracks"]] if obj.get("similarTracks") is not None else None,
            "artist_uuid": obj.get("artist_uuid")
        })
        return _obj


